package org.jlab.coda.jevio;

import java.util.EventListener;

/**
 * In SAX like behavior, implementors will listen for structures encountered when an event is parsed.
 * 
 * @author heddle
 * 
 */
public interface IEvioListener extends EventListener {

	/**
	 * Called when a structure is read while parsing an event.
	 * 
	 * NOTE: the user should NOT modify the event or the structure.
	 * 
	 * @param evioEvent the data type, BANK, SEGMENT, or TAGSEGMENT
	 * @param structure the full structure, including header
	 */
	public void gotStructure(EvioEvent evioEvent, IEvioStructure structure);
    
    /**
     * Starting to parse a new event.
     * @param evioEvent the event in question.
     */
    public void startEventParse(EvioEvent evioEvent);

    /**
     * Done parsing a new event.
     * @param evioEvent the event in question.
     */
    public void endEventParse(EvioEvent evioEvent);

}
